#include <array>
#include <algorithm>
#include <iostream>
#include <tuple>
#include <vector>

int distancia(int x1, int y1, int x2, int y2)
{
   int dx = x1 - x2;
   int dy = y1 - y2;

   return dx * dx + dy * dy;
}

struct distancia_con {
   bool operator()(std::tuple<int, int, char> p1, std::tuple<int, int, char> p2) const
   {
      auto d1 = distancia(x, y, std::get<0>(p1), std::get<1>(p1));
      auto d2 = distancia(x, y, std::get<0>(p2), std::get<1>(p2));

      return d1 < d2 || (d1 == d2 && p1 < p2);
   }

   int x;
   int y;
};

char clasifica(std::vector<std::tuple<int, int, char>>& puntos, int x, int y, int k)
{
   std::partial_sort(puntos.begin( ), puntos.begin( ) + std::min(k, int(puntos.size( ))), puntos.end( ), distancia_con{x, y});
   std::array<int, 26> cuenta = { };

   for (int i = 0; i < k; ++i) {
      cuenta[std::get<2>(puntos[i]) - 'A'] += 1;
   }

   return 'A' + std::max_element(cuenta.begin( ), cuenta.end( )) - cuenta.begin( );
}

int main( )
{
   int n;
   std::cin >> n;

   char tablero[n][n];
   std::vector<std::tuple<int, int, char>> puntos;

   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         std::cin >> tablero[i][j];

         if (tablero[i][j] != '?') {
            puntos.push_back(std::make_tuple(i, j, tablero[i][j]));
         }
      }
   }

   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         if (tablero[i][j] == '?') {
            tablero[i][j] = clasifica(puntos, i, j, 5);
            puntos.push_back(std::make_tuple(i, j, tablero[i][j]));
         }
      }
   }

   for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
         std::cout << tablero[i][j];
      }

      std::cout << '\n';
   }
}
