#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <fstream>
#include <tuple>
#include <vector>

int main( )
{
   std::srand(std::time(nullptr));

   constexpr auto N = 500;
   constexpr auto T = 10;
   constexpr auto S = 3;

   char tablero1[N][N];
   char tablero2[N][N];

   for (int i = 0; i < N; ++i) {
      for (int j = 0; j < N; ++j) {
         tablero1[i][j] = 'A' + std::rand( ) % S;
      }
   }

   auto t1 = &tablero1;
   auto t2 = &tablero2;

   for (int k = 0; k < T; ++k) {
      for (int i = 0; i < N; ++i) {
         for (int j = 0; j < N; ++j) {
            (*t2)[i][j] = (*t1)[i][j];

            if (std::rand( ) % 3 != 0) {
               continue;
            }

            int cuenta[S] = { };

            for (int x = -1; x <= 1; ++x) {
               for (int y = -1; y <= 1; ++y) {
                  int p1 = i + x;
                  int p2 = j + y;

                  if (p1 >= 0 && p1 < N && p2 >= 0 && p2 < N) {
                     cuenta[(*t1)[p1][p2] - 'A'] += 1;
                  }
               }
            }

            cuenta[(*t1)[i][j] - 'A'] -= 1;
            int mayoria = *std::max_element(cuenta, cuenta + S);

            char posibles[S];
            auto escribir = posibles;

            for (int i = 0; i < S; ++i) {
               if (cuenta[i] == mayoria) {
                  *escribir++ = 'A' + i;
               }
            }

            (*t2)[i][j] = posibles[std::rand( ) % (escribir - posibles)];
         }
      }

      std::swap(t1, t2);
   }

   std::ofstream ofs1("mapa_completo.txt");

   for (int i = 0; i < N; ++i) {
      for (int j = 0; j < N; ++j) {
         ofs1 << (*t1)[i][j];
      }

      ofs1 << '\n';
   }

   std::ofstream ofs2("mapa_entrada.txt");
   ofs2 << N << '\n';

   for (int i = 0; i < N; ++i) {
      for (int j = 0; j < N; ++j) {
         ofs2 << (std::rand( ) % 3 == 0 ? (*t1)[i][j] : '?');
      }

      ofs2 << '\n';
   }
}
